const fs = require('fs')

const package = require(process.cwd() + '/package.json')

if (!package) return console.log('No Package.json Found')

const publish = async (options = {
    name: '',
    version: '',
    keywords: '',
    description: '',
    license: '',
    repository: '',
    readme: '',
    author: ''
}) => {

    const needle = require('needle')

    const name = options['name']

    const version = options['version']

    const keywords = options['keywords']

    const description = options['description']

    const license = options['license']

    const repository = options['repository']

    const author = options['author']

    const readme = options['readme']

    const response = await needle('get', `http://192.168.9.206:3000/publish?data=${JSON.stringify({
        name: name,
        version: version,
        keywords: keywords,
        description: description,
        license: license,
        repository: repository,
        author: author,
        readme: readme.toString('hex')
    })}`)

    if (response.statusCode < 400 === 'Package Updated') {

        return true

    }

    return false
    
}

const published = publish({
    name: package.name,
    version: package.version,
    keywords: package.keywords,
    description: package.description,
    license: package.license,
    repository: package.repository?.url,
    readme: fs.readFileSync(process.cwd() + '/README.md'),
    author: package.author
})

if (published) console.log('Package Published')

else console.log('Package Declined')